/*
* Title: WebHamsters
* Description: Javascript library to add multi-threading support to javascript by exploiting concurrent web workers
* Author: Austin K. Smith 
* Contact: austin@asmithdev.com
* Copyright: 2015 Austin K. Smith - austin@asmithdev.com
* License: Artistic License 2.0
*/
var hamsters={version:"2.8",debug:!1,cache:!1,maxThreads:Math.ceil(1.25*(navigator.hardwareConcurrency||1)),tools:{},wheel:{legacy:!1,queue:{running:[],pending:[]},tasks:[],errors:[],setup:{}}};hamsters.wheel.wakeUp=function(){"use strict";hamsters.tools.isIE=function(e){return new RegExp("msie"+(isNaN(e)?"":"\\s"+e),"i").test(navigator.userAgent)},hamsters.wheel.setup.isLegacy=function(e){try{!window.Worker||-1!==navigator.userAgent.indexOf("Kindle/3.0")||-1!==navigator.userAgent.indexOf("Mobile/8F190")||-1!==navigator.userAgent.indexOf("IEMobile")||hamsters.tools.isIE(10)?hamsters.wheel.legacy=!0:-1!==navigator.userAgent.toLowerCase().indexOf("firefox")&&(window.firefox=window.firefox||!0)}catch(r){hamsters.wheel.legacy=!0}e&&e(hamsters.wheel.legacy)},hamsters.isLegacy=function(){return hamsters.wheel.legacy},hamsters.checkErrors=function(){var e=hamsters.wheel.errors||[];return{msg:"There are currently "+e.length+" errors captured in the wheel",total:e.length,errors:e}},hamsters.tools.splitArray=function(e,r){e.length&&!e.slice&&(e=hamsters.wheel.normalizeArray(e));var t=[],a=0;if(e){for(var s=e.length,n=Math.ceil(s/r);s>a;)t.push(e.slice(a,a+=n));return t}return[]},hamsters.tools.randomArray=function(e,r){if(!e||!r)return void hamsters.wheel.errors.push({msg:"Unable to generate random array, missing required params"});var t={count:e};hamsters.run(t,function(){for(var e=t.count,r=0;e>r;)rtn.data[rtn.data.length]=Math.round(99*Math.random()+1),r+=1},function(e){r&&r(e)},1,!1,"Int32",!1)},hamsters.wheel.checkCache=function(e,r){for(var t,a=0,s=sessionStorage.length;s>a;a+=1)if(t=JSON.parse(sessionStorage[a]),t&&t["#"]===e&&t.dT===r){var n=t.oP;return r&&!hamsters.wheel.legacy&&(n=hamsters.wheel.processDataType(r,t.oP)),n}},hamsters.wheel.memoize=function(e,r,t,a){var s=hamsters.wheel.hashResult({func:e,dT:a,input:r});if(!hamsters.wheel.checkCache(s,a))try{sessionStorage.setItem(sessionStorage.length,JSON.stringify({"#":s,dT:a,oP:t}))}catch(n){if("QuotaExceededError"===n.name){sessionStorage.clear();try{sessionStorage.setItem(sessionStorage.length,JSON.stringify({"#":s,dT:a,oP:t}))}catch(o){return}}}},hamsters.wheel.compareArrays=function(e,r){return e.length!==r.length?!1:e.every(function(e,t){return e===r[t]})},hamsters.wheel.setup.populateElements=function(e,r){for(var t=0,a=e;a>t;t+=1)hamsters.wheel.setup.getOrCreateElement(t);r&&r.call()},hamsters.wheel.setup.getOrCreateElement=function(e){var r=document.getElementById("hamster"+e)||null;if(!r){var t=hamsters.wheel.giveHamsterWork();return r=document.createElement("script"),r.type="javascript/worker",r.id="hamster"+e,r.text="("+String(t)+"());",document.getElementsByTagName("head")[0].appendChild(r),r}return r},hamsters.wheel.giveHamsterWork=function(){var work=function(){var params,respond=function(e,r){if(params.dataType&&"na"!==params.dataType){var t=processDataType(params.dataType,e.data);e.data=t.buffer,e.dataType=params.dataType,self.postMessage({results:e||null,msg:r||""},[t.buffer])}else self.postMessage({results:e||null,msg:r||""})},processDataType=function(e,r){return"uint32"===e?new Uint32Array(r):"uint16"===e?new Uint16Array(r):"uint8"===e?new Uint8Array(r):"uint8clamped"===e?new Uint8ClampedArray(r):"int32"===e?new Int32Array(r):"int16"===e?new Int16Array(r):"int8"===e?new Int8Array(r):"float32"===e?new Float32Array(r):"float64"===e?new Float64Array(r):r};self.onmessage=function(e){var rtn={success:!0,data:[]};if(params=e.data,"string"==typeof params&&(params=JSON.parse(e.data)),params.dataType&&"na"!==params.dataType&&"object"==typeof params.array&&(params.array=processDataType(params.dataType,params.array)),params.fn){var fn=eval("("+params.fn+")");fn&&"function"==typeof fn?(fn(),respond(rtn)):(rtn.success=!1,rtn.error="Missing function",rtn.msg="Error encounted check errors for details",respond(rtn))}}};return work},hamsters.wheel.sort=function(e,r){return"desc"===r?Array.prototype.sort.call(e,function(e,r){return r-e}):"asc"===r?Array.prototype.sort.call(e,function(e,r){return e-r}):"ascAlpha"===r?e.sort():"descAlpha"===r?e.reverse():void 0},hamsters.run=function(e,r,t,a,s,n,o,h){if(!e||!r)return"Error processing for loop, missing params or function";var l=hamsters.wheel.tasks.length;a=a||hamsters.maxThreads,hamsters.wheel.newTask(l,a,h,n,r,t);var i=hamsters.wheel.tasks[l];t=t||null;var u={array:[]};if(u.fn=r.toString(),n=n?n.toLowerCase():"na",hamsters.cache&&e.array&&0!==e.array.length){o=o||!0;var m=hamsters.wheel.hashResult({func:r,dT:"na",input:e.array}),c=hamsters.wheel.checkCache(m,n);if(c&&t)return void setTimeout(function(){t(c),hamsters.wheel.tasks[l]=null},4)}var p;for(p in e)e.hasOwnProperty(p)&&"array"!==p&&(u[p]=e[p]);u.dataType=n||null;var w=e.array||null;e.array&&1!==i.threads&&(w=hamsters.tools.splitArray(e.array,i.threads));for(var f=0;f<i.threads;)w&&1!==i.threads?hamsters.wheel.newWheel(w[f],u,s,t,l,f,null,null,o):hamsters.wheel.newWheel(w,u,s,t,l,f,null,null,o),f+=1},hamsters.wheel.newTask=function(e,r,t,a,s,n){hamsters.wheel.tasks.push({id:e,workers:[],count:0,threads:r,input:[],dataType:a||null,fn:s||null,output:[],order:t||null,callback:n})},hamsters.wheel.trackInput=function(e,r,t,a,s){e.input.push({input:r,workerid:t,taskid:a,params:s,start:(new Date).getTime()})},hamsters.wheel.poolThread=function(e,r,t,a,s,n,o,h){e.pending.push({memoize:h,input:r,params:t,workerid:a,callback:s,taskid:n,aggregate:o})},hamsters.wheel.trackThread=function(e,r,t){e.workers[e.workers.length]=t,r.running[r.running.length]=t},hamsters.wheel.legacyProcessor=function(food,inputArray,callback){setTimeout(function(){var params=food,rtn={success:!0,data:[]},respond=function(e){callback&&callback(e)};if(params.fn){params.array=inputArray;var fn=eval("("+params.fn+")");if(fn&&"function"==typeof fn)try{fn(),respond(rtn)}catch(exception){rtn.success=!1,rtn.error=exception,rtn.msg="Error encounted check errors for details",respond(rtn)}}},4)},hamsters.wheel.createHamster=function(e){var r=hamsters.wheel.setup.getOrCreateElement(e),t=hamsters.wheel.createBlob(r.textContent),a=window.URL.createObjectURL(t);return{worker:new Worker(a),dataBlob:t,blobUri:a}},hamsters.wheel.sendRequest=function(e,r,t,a){var s=new XMLHttpRequest;s.open(e,r),s.responseType=t,s.onload=function(){a(this.response)},s.send()},hamsters.wheel.fetchArrayBuffer=function(e,r){var t=window.URL.createObjectURL(hamsters.wheel.createBlob(e));hamsters.wheel.sendRequest("GET",t,"arraybuffer",function(e){r&&r(e)})},hamsters.wheel.createBlob=function(e){if(Blob)return new Blob([e],{type:"application/javascript"});var r=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder;if(r){var t=new r;return t.append([e],{type:"application/javascript"}),t=t.getBlob()}},hamsters.tools.aggregate=function(e,r){return e?e.length>20?e:r?hamsters.wheel.aggregateTypedArrays(e,r):e.reduce(function(e,r){return e.concat(r)}):void console.error("Missing array")},hamsters.wheel.getOutput=function(e,r,t){return r?hamsters.tools.aggregate(e,t):e},hamsters.wheel.processQueue=function(e,r){var t=hamsters.wheel.queue.pending.shift();t&&hamsters.wheel.newWheel(t.input,t.params,t.aggregate,t.callback,t.taskid,t.workerid,e,r,t.memoize)},hamsters.wheel.terminateHamster=function(e){e&&(e.blob.close?e.blob.close():e.blob.msClose?e.blob.msClose():e.blob.slice&&(e.blob=e.blob.slice(0,0)),window.URL.revokeObjectURL(e.uri))},hamsters.wheel.trainHamster=function(e,r,t,a,s,n,o,h){n.onmessage=function(l){var i=hamsters.wheel.queue;0===i.pending.length&&setTimeout(function(){n.terminate(),hamsters.wheel.terminateHamster(o)},4),i.running.splice(i.running.indexOf(e),1);var u=hamsters.wheel.tasks[a];if(!u)return hamsters.wheel.errors=hamsters.wheel.errors.concat({timeStamp:l.timeStamp,msg:"Error, unable to match thread to task, throwing exception",taskid:a,workerid:s,aggregate:r,callback:t}),void console.error("Fatal Exception, unable to match thread #"+s+" to task #"+a+", cannot continue. Check errors for more details");u.workers.splice(u.workers.indexOf(s),1);var m=l.data.results;if(m.dataType&&"object"==typeof m.data&&(m.data=hamsters.wheel.processDataType(m.dataType,m.data)),u.output[s]=m.data,0===u.workers.length&&u.count===u.threads){var c=hamsters.wheel.getOutput(u.output,r,m.dataType);if(t&&(hamsters.debug&&console.info("Execution Complete! Elapsed: "+(l.timeStamp-u.input[0].start)/1e3+"s"),t(u.order?hamsters.wheel.sort(c,u.order):c),hamsters.wheel.tasks[a]=null,hamsters.cache&&h!==!1)){var p=u.input[0].input;c.length>0&&!m.dataType?setTimeout(hamsters.wheel.memoize(u.fn,p,c,"na"),4):c.length>0&&m.dataType&&setTimeout(hamsters.wheel.memoize(u.fn,p,hamsters.wheel.normalizeArray(c),m.dataType),4)}}else"verbose"===hamsters.debug&&console.info("Hamster #"+e+" finished @ "+l.timeStamp);0!==i.pending.length&&hamsters.wheel.processQueue(n,o)},n.onerror=function(r){n.terminate();var t="Error Hamster #"+e+": Line "+r.lineno+" in "+r.filename+": "+r.message;hamsters.wheel.errors=hamsters.wheel.errors.concat({msg:t}),console.error(t)}},hamsters.wheel.normalizeArray=function(e){for(var r=[],t=0,a=e.length;a>t;t++)r.push(e[t]);return r},hamsters.wheel.aggregateTypedArrays=function(e,r){for(var t,a=0,s=0,n=0,o=e.length;o>n;n+=1)a+=e[n].length;t=hamsters.wheel.processDataType(r,a);for(var h=0,l=e.length;l>h;h+=1)t.set(e[h],s),s+=e[h].length;return t},hamsters.wheel.processDataType=function(e,r){return"uint32"===e?new Uint32Array(r):"uint16"===e?new Uint16Array(r):"uint8"===e?new Uint8Array(r):"uint8clamped"===e?new Uint8ClampedArray(r):"int32"===e?new Int32Array(r):"int16"===e?new Int16Array(r):"int8"===e?new Int8Array(r):"float32"===e?new Float32Array(r):"float64"===e?new Float64Array(r):r},hamsters.wheel.generateHash=function(e){e=String(e);for(var r=0,t=e.length-1;t>=0;t--)r+=(r<<5)-r+e.charCodeAt(t)&4294967295;return r},hamsters.wheel.hashResult=function(e){var r=0;for(var t in e)e.hasOwnProperty(t)&&(r+=hamsters.wheel.generateHash("object"==typeof e[t]&&e[t].length&&!e[t].slice?t+String(hamsters.wheel.normalizeArray(e[t])):t+e[t]));return r},hamsters.wheel.feedHamster=function(e,r,t){if(t&&r.dataType?r.array=hamsters.wheel.processDataType(r.dataType,t):t&&(r.array=t),r.array&&r.array.buffer){var a=r.array.buffer;r.array=a,e.postMessage(r,[a])}else e.postMessage((window.chrome||window.firefox)&&r.array.length<=35e6?JSON.stringify(r):r)},hamsters.wheel.setup.isLegacy(function(e){e?hamsters.wheel.newWheel=function(e,r,t,a,s,n,o,h,l){var i=hamsters.wheel.tasks[s];if(!i)return hamsters.wheel.errors.push({msg:"Error, unable to match thread to task, throwing exception",params:r,aggregate:t,callback:a}),void console.error("Error, unable to match thread to task "+s+", throwing exception. Check errors for more details");var u=hamsters.debug;hamsters.wheel.legacyProcessor(r,e,function(e){if(i.count++,i.output[n]=e.data,i.count===i.threads){var r=hamsters.wheel.getOutput(i.output,t,e.dataType);a&&(u&&console.info("Execution Complete! Elapsed: "+((new Date).getTime()-i.input[0].start)/1e3+"s"),a(r),hamsters.wheel.tasks[s]=null,hamsters.cache&&l!==!1&&(e.data.length>0&&!e.dataType?setTimeout(hamsters.wheel.memoize(i.fn,i.input,e.data,"na"),4):e.data.length>0&&e.dataType&&setTimeout(hamsters.wheel.memoize(i.fn,i.input,hamsters.wheel.normalizeArray(e.data),e.dataType),4)))}})}:(hamsters.wheel.newWheel=function(e,r,t,a,s,n,o,h,l){var i=hamsters.wheel.tasks[s];if(!i)return hamsters.wheel.errors.push({msg:"Error, unable to match thread to task, throwing exception",params:r,aggregate:t,callback:a}),void console.error("Error, unable to match thread to task "+s+", throwing exception. Check errors for more details");var u=hamsters.wheel.queue;if(hamsters.maxThreads&&hamsters.maxThreads<=u.running.length)return void hamsters.wheel.poolThread(u,e,r,n,a,s,t,l);var m=n||i.count,c=hamsters.debug;(c||l)&&(hamsters.wheel.trackInput(i,e,m,s,r),"verbose"===c&&console.info("Spawning Hamster #"+m+" @ "+(new Date).getTime())),hamsters.wheel.trackThread(i,u,m);var p,w=h||null;o||(p=hamsters.wheel.createHamster(m),o=p.worker,w={blob:p.dataBlob,uri:p.blobUri}),hamsters.wheel.trainHamster(m,t,a,s,m,o,w,l),hamsters.wheel.feedHamster(o,r,e),i.count++},hamsters.wheel.setup.populateElements(hamsters.maxThreads))})},hamsters.wheel.wakeUp();